#include <fstream>

///
using namespace std;

/// Eine einfache Klasse fr Punkte im R^2
class Point
{ 
  public:
  ///
  double x;
  ///
  double y;

  ///
  friend istream& operator>> (istream& is, Point& p)
  {
    is >> p.x >> p.y; 
    return is;
  }

  ///
  friend ostream& operator<< (ostream& os, const Point& p)
  {
    os << p.x << "  " << p.y << endl;
    return os;
  }
}///
;

/** Eine Klasse zur Berechnung von umschlieenden Rechtecken 
    fr Punktmengen
*/
class BoundingBox
{
  public:

  /// linke untere Ecke
  Point min;
  /// rechte obere Ecke
  Point max;

  ///
  BoundingBox()
  {
    min.x = min.y = 1e100;
    max.x = max.y = -1e100;
  }
  
  /// aktualisiert die Bounding Box bei Hinzunahme des Punktes p
  void operator()(const Point &p)
  {
    if (p.x < min.x) min.x = p.x;
    if (p.y < min.y) min.y = p.y;
    if (p.x > max.x) max.x = p.x;
    if (p.y > max.y) max.y = p.y;
  }

  /// gibt die Bounding Box aus 
  friend ostream& operator<< (ostream& os, const BoundingBox& bb)
  {
    os << "[" << bb.min.x << "," << bb.max.x << "]" 
       << " x [" << bb.min.y << "," << bb.max.y << "]" << endl; 
    return os;
  }
}///
;
