#ifndef RASTER_DATA_H
#define RASTER_DATA_H

#include <fstream>
#include <GL/glut.h>

using namespace std;

/// Eine Klasse zur Reprsentation von Rasterdaten 
class RasterData

{ public:

  /// Anzahl der Spalten
  int     ncols; 
  /// Anzahl der Zeilen
  int     nrows;
  /// x-Koordinate der linken unteren Ecke
  int xllcorner;
  /** y-Koordinate der linken unteren Ecke

      xllcorner und yllcorner beziehen sich auf die 
      sdwestliche Rasterzelle. Die Sdwestecke
      des Gebietes befindet sich im Mittelpunkt dieser
      Zelle. Es ist also jeweils cellsize/2 zu addieren.
  */
  int yllcorner;
  /// Zellgre in Meter
  int cellsize;
  /// NODATA-Wert
  int NODATA_value;
  /// Hhenwerte zeilenweise (unten links beginnend)
  GLubyte *Image;
  
  /** extrahiert aus den Hhendaten einen rechteckigen Teilbereich
      der Lnge width und der Hhe height. Die linke untere Ecke
      dieses Bereiches liegt an der Position (offsetX,offsetY) des 
      Hhenfeldes.
  */
  void subImage(int width,int height,int offsetX,int offsetY,GLubyte *subimage);
  /// liest die Hhendaten aus einem input stream
  friend istream& operator>> (istream&,RasterData&);
  /// schreibt die Headerinformationen auf einen output stream
  friend ostream& operator<< (ostream&,const RasterData&);
}
;

#endif
