#include <cstdlib>
#include "RasterWindow.h"

///
RasterWindow::RasterWindow(GlutAdmin &admin,int width,int height,int initX,int initY,char* title)
{
   glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE);
   glutInitWindowSize(width,height);
   glutInitWindowPosition(initX,initY);

   admin.CreateWindow(title,this);

   glutAddMenuEntry("Quit",0);
   glutAttachMenu(GLUT_RIGHT_BUTTON);

   wx = width;
   wy = height;
   Image = new GLubyte[wx*wy];
   mx0 = my0 = rx0 = ry0 = 0;
}

///
RasterWindow::~RasterWindow()
{
   delete Image;
   glutDestroyWindow(ID);
}

///
void RasterWindow::MenuFunc(int value)
{ 
  switch(value)
  { 
    case 0: exit(EXIT_SUCCESS);
  }
}

///
void RasterWindow::MouseFunc(int button, int state, int x, int y)
{
  if (button != GLUT_LEFT_BUTTON) return;
  if (state == GLUT_DOWN)
  { mx0 = x; my0 = y;
  }
/*
  if (state == GLUT_UP)
  { rx0 += mx0-x;
    ry0 -= my0-y;
    glutPostRedisplay();
  }
*/
}

///
void RasterWindow::MotionFunc(int x, int y)
{
  rx0 += mx0-x;
  ry0 -= my0-y;
  mx0 = x; 
  my0 = y;
  glutPostRedisplay();
}

///
void RasterWindow::DisplayFunc()

{ 
  glClear( GL_COLOR_BUFFER_BIT );
  glRasterPos2i(0,0);
  glPixelStorei(GL_UNPACK_ALIGNMENT,1);

  RD.subImage(wx,wy,rx0,ry0,Image);

  glDrawPixels(wx,wy,GL_LUMINANCE,GL_UNSIGNED_BYTE,Image);
  glutSwapBuffers();
}

///
void RasterWindow::ReshapeFunc(int newwidth, int newheight)
{  
  wx = newwidth; 
  wy = newheight;
  glViewport(0, 0, GLint(wx), GLint(wy));
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluOrtho2D(0,GLdouble(wx),0,GLdouble(wy));
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  delete Image;
  Image = new GLubyte[wx*wy];
}

