#ifndef RASTER_WINDOW_H
#define RASTER_WINDOW_H

#include "glutAdmin.h"
#include "RasterData.h"

/// Eine Klasse fr Fenster, in denen Rasterdaten visualsiert werden
class RasterWindow : public GlutWindow
{
public:

   /// die Rasterdaten
   RasterData RD;
   /// der dargestellte Ausschnitt der Rasterdaten
   GLubyte    *Image;
   /// die Breite dieses Ausschnitts
   int        wx;
   /// die Hhe dieses Ausschnitts
   int        wy;
   /// die x-Position des letzten Mausklicks in Fensterkoordinaten
   int        mx0;
   /// die y-Position des letzten Mausklicks in Fensterkoordinaten
   int        my0;
   /// die x-Position der linken unteren Ecke des Ausschnitts in Rasterkoordinaten
   int        rx0;
   /// die y-Position der linken unteren Ecke des Ausschnitts in Rasterkoordinaten
   int        ry0;

   /** kreiert ein Fenster namens title mit der Breite width und Hhe height
       an der Bildschirmposition (initx,inity)
   */
   RasterWindow(GlutAdmin &admin,int width,int height,int initX,int initY,char* title);
   ///
   ~RasterWindow();

   ///
   void DisplayFunc();
   ///
   void ReshapeFunc(int newwidth,int newheight);   
   ///
   void MenuFunc(int value);
   ///
   void MotionFunc(int x,int y);
   ///
   void MouseFunc(int button,int state,int x,int y);
}///
;

#endif
