#include <cstdlib>
#include <algorithm>
//#include <minmax.h>
#include "VectorWindow.h"

///
class DrawPoint
{
  public:

  ///
  void operator()(const Point &p)
  {
//  cout << p;
    glVertex2d(p.x,p.y);
  }
}///
;

///
VectorWindow::VectorWindow(GlutAdmin &admin,int width,int height,int initX, int initY, char *title)
{
   glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE );
   glutInitWindowSize(width,height);
   glutInitWindowPosition(initX,initY);

   admin.CreateWindow(title,this);

   glutAddMenuEntry("Quit",0);
   glutAttachMenu(GLUT_RIGHT_BUTTON);
}

///
VectorWindow::~VectorWindow()
{
   glutDestroyWindow(ID);
}

///
void VectorWindow::MenuFunc(int value)
{ 
  switch(value)
  { 
    case 0: exit(EXIT_SUCCESS);
  }
}

///
void VectorWindow::DisplayFunc()

{ 
  glClear(GL_COLOR_BUFFER_BIT);
  glColor3f(0.0,0.0,1.0);
  glPushMatrix();
  double s = 2.0/max(bb.max.x-bb.min.x,bb.max.y-bb.min.y);
  glScaled(s,s,s);
  glTranslated(-0.5*(bb.max.x+bb.min.x),-0.5*(bb.max.y+bb.min.y),0.0);
  glBegin(GL_LINE_STRIP);
  for_each(C.begin(),C.end(),DrawPoint());
  glEnd();
/*
  glColor3f(1.0,0.0,0.0);
  glPointSize(3.0);
  glBegin( GL_POINTS);
  for_each(C.begin(),C.end(),DrawPoint());
  glEnd();
*/
  glPopMatrix();
  glutSwapBuffers();
}

///
void VectorWindow::ReshapeFunc(int newwidth, int newheight)
{  
  glViewport(0, 0, GLint(newwidth), GLint(newheight));
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  if (newwidth > newheight)
  {
    GLfloat w = GLfloat(newwidth)/GLfloat(newheight);
    gluOrtho2D(-w, w, -1.0, 1.0);
  }
  else
  {
    GLfloat h = (GLfloat) newheight / (GLfloat) newwidth;
    gluOrtho2D(-1.0, 1.0, -h, h);
  }
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
}

