#include <cstdlib>
#include "myWindow.h"

///
MyWindow::MyWindow(GlutAdmin &admin,int width,int height,int initX,int initY, char *title)
{
   glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE);
   glutInitWindowSize(width,height);
   glutInitWindowPosition(initX, initY);

   admin.CreateWindow(title, this);

   glutAddMenuEntry("Quit",0);
   glutAttachMenu(GLUT_RIGHT_BUTTON);
}

///
MyWindow::~MyWindow()
{
   glutDestroyWindow(ID);
}

///
void MyWindow::DisplayFunc()
{ 
  glClear( GL_COLOR_BUFFER_BIT );
  glPushMatrix();
  glScalef(0.8,0.8,1);
  glLineWidth(3);
  glColor3f(0,1,0);
/*
  glBegin(GL_LINE_LOOP);
  glVertex2f(0,1);   
  glVertex2f(-1,0);  
  glVertex2f(-1,-1);
  glVertex2f(0,0);
  glVertex2f(1,-1); 
  glVertex2f(1,0);   
  glEnd();
*/

//glTranslatef(-1,0,0);
//glRotatef(90,0,0,1);

  glBegin(GL_LINE_STRIP);
  glVertex2f(-1,-1);
  glVertex2f(-1,0);
  glVertex2f(0,1);
  glVertex2f(1,0);
  glVertex2f(1,-1);
  glVertex2f(-1,-1);
  glVertex2f(1,0);
  glVertex2f(-1,0);
  glVertex2f(1,-1);
  glEnd();

  glPopMatrix();
  glutSwapBuffers();
}

///
void MyWindow::ReshapeFunc(int newwidth, int newheight)
{
  glViewport(0, 0, GLint(newwidth),GLint(newheight));
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  if (newwidth>newheight)
  {
    GLfloat w = GLfloat(newwidth)/GLfloat(newheight);
    gluOrtho2D(-w, w, -1.0, 1.0);
  }
  else
  {
    GLfloat h = GLfloat(newheight)/GLfloat(newwidth);
    gluOrtho2D(-1.0, 1.0, -h, h);
  }
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
}

///
void MyWindow::MenuFunc(int value)
{
  switch(value)
  {
    case 0: exit(EXIT_SUCCESS);
  }
}

